package weaving;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.content.IContentType;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.content.IContentTypeManager;

import parser.ACCASTAdvice;
import parser.ACCSourceParser;

import org.eclipse.cdt.core.dom.ast.ASTVisitor;
import org.eclipse.cdt.core.dom.ast.IASTCompoundStatement;
import org.eclipse.cdt.core.dom.ast.IASTFunctionDeclarator;
import org.eclipse.cdt.core.dom.ast.IASTFunctionDefinition;
import org.eclipse.cdt.core.dom.ast.IASTName;
import org.eclipse.cdt.core.dom.ast.IBinding;
import org.eclipse.cdt.core.dom.ast.IProblemBinding;
import org.eclipse.cdt.core.parser.EndOfFileException;
import org.eclipse.cdt.internal.core.dom.parser.ASTQueries;
import org.eclipse.cdt.internal.core.dom.parser.BacktrackException;
import org.eclipse.cdt.internal.core.parser.scanner.Token;
import org.eclipse.cdt.internal.core.parser.scanner.CPreprocessor;
import org.eclipse.cdt.internal.core.dom.parser.cpp.GNUCPPSourceParser;
import org.eclipse.cdt.codan.internal.checkers.ProblemBindingChecker;


import utils.IConstants;

privileged aspect Joinpoint {
	
	// Test
	private static IContentTypeManager manager = Platform.getContentTypeManager();
	private static IContentType a_cc_type = manager.getContentType("org.aspectc.acdt.language.contenttypes.cc");
	private static IContentType a_h_type = manager.getContentType("org.aspectc.acdt.language.contenttypes.h");
	private static IContentType cc_type = manager.getContentType("org.eclipse.cdt.core.cxxSource");
	private static IContentType h_type = manager.getContentType("org.eclipse.cdt.core.cxxHeader");
	
	IContentType around(IProject project, String str):
		execution(* CContentTypes.getContentType(IProject, String)) &&
		args (project, str) {

		// get the content type, which the CDT assumes for the file
		IContentType tp = proceed(project, str);
		
		// find out whether the project has the AspectC++ nature
		boolean is_ac_project;
		try {
			is_ac_project = project.hasNature(IConstants.ACDT_NATURE_ID);
		} catch (CoreException ex) {
			is_ac_project = false;
		}
		
		// Check whether the file is in the project. This is the case for system include
		// files. Files outside the project are no AspectC++ files.
		// If this is not an AspectC++ project or if the file is not in the project,
		// return CDT's chosen content type.
		if (!is_ac_project || project.findMember(str) == null)
			return tp;

		// Substitute C/C++ types by the corresponding AspectC++ content types.
		// Therefore, Eclipse will chose the right language and parser object.
		if (tp != null && cc_type != null && a_cc_type != null && 
				h_type != null && a_h_type != null) {
			// TODO: check -k flag
			if (tp.isKindOf(h_type)) {
				tp = a_h_type;
			}
			else if (tp.isKindOf(cc_type)) {
				tp = a_cc_type;
			}
		}
		return tp;
	}
	
	private String fs = System.getProperty("file.separator");
	private boolean inProgress = false;
	
	
	/*before(String[] str) : initialization(ScannerInfo.new(Map, String[])) && args(m, str) {
		System.out.println(thisJoinPoint.toString());
		for (int i=0; i < str.length; i++) {
			System.out.println(str);
		}
	}*/
	
	
	/**
	 * clears the model before it is parsed and calculate it afterwards
	 */
	//pointcut par() : execution(* AbstractGNUSourceCodeParser.parse());
//	pointcut par() : target(ACCSourceParser) && call(* parse()) && !within(Joinpoint);
	
	
//	before() : par() {
//		if (!ACDTUtils.createdResolution) {
//			Model model = Model.getModel();
//			model.clearModel();
//			//System.out.println("clear Model: "+model.getFilename());
//		}
//		
//	}
//	
//	after() : par() {
//		if (!ACDTUtils.createdResolution) {
//			Model model = Model.getModel();
//			model.calculateModel();
//			//System.out.println("calculate Model: "+model.getFilename());
//		}
//		
//	}
	
	/**
	 * resolves inclusions
	 * @param inc File that is included
	 * @param curr Current File
	 */
//	pointcut inclusions(String inc, String curr) : execution(* CPreprocessor.getAbsoluteInclusionPath(String, String))
//		&& args(inc, curr);
//
//	after(String inc, String curr): inclusions(inc, curr) {
//		if (ACDTUtils.getProjectName()==null)  return;
//		else {
//			String pr = ACDTUtils.getProjectName();
//		String includePath = pr+fs+inc;
//
//		String current;
//		if (curr.contains(fs+pr+fs)) {
//			current = curr.substring(curr.indexOf(fs+pr+fs));
//		}
//		else {
//			current = curr;
//		}
//		
//		if (inc.contains(".h")||inc.contains(".ah")) { //if include is a file 
//			//find out if include belongs to project
//			//String project = ACDTUtils.getProjectName();
//			
//			try {
//				//IProject pro = (IProject) ResourcesPlugin.getWorkspace().getRoot().findMember(project);
//				IProject pro = ACDTUtils.getProject();
//				if (pro!=null && pro.exists(new Path(inc))) {
//					Model.insertInclude(current, includePath);
//					Model.insertIncludedBy(current, includePath);
//				}
//			} catch (ClassCastException e) {
//				
//			}
//		}	
//		
//		}
//		
//	}
	
//	//try if model needs a forced creation
//	pointcut force(String path) : call(* Model.forceCreate(String))
//					&& args(path);
//	
//	after(String path) : force(path) {
//		String pth = ACDTUtils.getLastPathSegment(path);
//		
//		IFile f = ACDTUtils.getFile(pth);
//		String file = ACDTUtils.combine(ACDTUtils.getProjectName(), pth);
//		IScanner s = createScanner(f);
//		IProject project = ACDTUtils.getProject(file);
//		ISourceCodeParser p = createParser(s, project,file);
//		if (p!=null) {
//			if (!inProgress) {
//				inProgress=true;
//				p.parse();
//			}
//			inProgress=false;
//		} 
//		
//	}
//	
//	private IScanner createScanner(IFile file) {
//		//content
//		FileContent content = FileContent.create(file);
//		//IScannerInfo
//		IScannerInfoProvider provider = CCorePlugin.getDefault().getScannerInfoProvider(ACDTUtils.getProject());
//		IScannerInfo si = provider.getScannerInformation(ACDTUtils.getProject());	
//		
//		//ParserLanguage
//		ParserLanguage pl = ParserLanguage.CPP;
//		
//		//ParserLogService
//		IParserLogService ls = new DefaultLogService();
//		
//		//ScannerExtensionConfiguration
//		IScannerExtensionConfiguration sec = new ACCScannerExtensionConfiguration();
//		
//		IScanner s = new CPreprocessor(content, si, pl, ls, sec, null);
//		
//		return s;
//
//	}
//	
//	@SuppressWarnings("restriction")
//	private ISourceCodeParser createParser(IScanner scanner, IProject pro, String path) {
//		//parserMode
//		ParserMode pm = ParserMode.COMPLETE_PARSE;
//		//logService
//		IParserLogService ls = new DefaultLogService();
//		//parserExtensionConfiguration
//		ICPPParserExtensionConfiguration pec = GPPParserExtensionConfiguration.getInstance();
//		//index
//		ICProject project = null;
//		
//		project = CModelManager.getDefault().create(pro);
//		
//		if (project == null) return null;
//		
//		IIndex index;
//		try {
//			index = CCorePlugin.getIndexManager().getIndex(project);
//			Model model = Model.getModel(path);
//			ISourceCodeParser parser =  new ACCSourceParser(scanner, pm, ls, pec, index, model);
//			
//			return parser;
//		} catch (CoreException e) {
//			e.printStackTrace();
//		}
//		
//		return null;
//	}
	
//	void func1() {}
//	void func2() { func1(); fu(); }
//	void fu() {}
//	
//	before() : execution(void Joinpoint.func*()) {}
//	before() : call(void Joinpoint.func1()) {}
	
}